Rygel.MediaObject – librygel-server Reference Manual

# MediaObject

## Object Hierarchy:

## Description:

public abstract class MediaObject : Object

Represents a media object (container or item).

The derived RygelMediaContainer class represents a container and the derived MediaItem classes represent media items.

All known sub-classes:

- ImageItem
- AudioItem
- PhotoItem
- VideoItem

- PlaylistItem
- MusicItem
- MediaFileItem

- MediaItem
- SimpleContainer
- MediaContainer

Required by:

- UpdatableObject

Namespace: Rygel
Package: librygel-server

## Content:

### Properties:

- public string id { construct set; get; }
- public string ref_id { set; get; }
- public string upnp_class { construct set; get; }
- public string date { set; get; }
- public string creator { set; get; }
- public uint64 modified { set; get; }
- public uint object_update_id { set; get; }
- public string artist { set; get; }
- public string genre { set; get; }
- public weak MediaContainer parent { construct set; get; }
- public MediaContainer parent_ref { set; get; }
- public string title { construct set; get; }
  The human-readable title of this container or item. These variables will be substituted:
- public virtual OCMFlags ocm_flags { get; }

### Static methods:

- public static string? apply_replacements (HashTable<string,string> replacement_pairs, string? source_string)
  Replace each key in replacement_pairs with its corresponding value in the source_string and return the result.

### Creation methods:

- public MediaObject ()

### Methods:

- public List<string> get_uris ()
- public string? get_primary_uri ()
- public virtual void add_uri (string uri)
- public override void constructed ()
- public async File? get_writable (Cancellable? cancellable) throws Error
  Fetches a File object for any writable URI available for this object.
- public async ArrayList<File> get_writables (Cancellable? cancellable) throws Error
  Fetches File objects for all writable URIs available for this object.
- public List<MediaResource> get_resource_list ()
  Return the MediaResource list.
- public MediaResource? get_resource_by_name (string resource_name)
- public abstract DIDLLiteObject? serialize (Serializer serializer, HTTPServer http_server) throws Error
- public void serialize_resource_list (DIDLLiteObject didl_object, HTTPServer http_server) throws Error
  Serialize the resource list
- public abstract DataSource? create_stream_source_for_resource (HTTPRequest request, MediaResource resource) throws Error
  Create a stream source for the given resource
- protected int compare_string_props (string prop1, string prop2)
- protected int compare_int_props (int prop1, int prop2)

### Fields:

- public weak MediaContainer parent_ptr

### Inherited Members:

All known members inherited from class GLib.Object

- interface_find_property
- interface_install_property
- interface_list_properties
- @new
- new_valist
- newv
- new_with_properties
- add_toggle_ref
- add_weak_pointer
- bind_property
- connect
- constructed
- disconnect
- dispose
- dup_data
- dup_qdata
- force_floating

- freeze_notify
- @get
- get_class
- get_data
- get_property
- get_qdata
- get_type
- getv
- is_floating
- notify_property
- @ref
- ref_sink
- replace_data
- replace_qdata
- remove_toggle_ref
- remove_weak_pointer
- @set

- set_data
- set_data_full
- set_property
- set_qdata
- set_qdata_full
- set_valist
- setv
- steal_data
- steal_qdata
- thaw_notify
- unref
- watch_closure
- weak_ref
- weak_unref
- notify
- ref_count